unit u_net_ibx_update;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, System.ComponentModel, Borland.Vcl.StdCtrls, Borland.Vcl.Db,
  Borland.Vcl.IBDatabase, Borland.Vcl.IBSQL, Borland.Vcl.Grids,
  Borland.Vcl.DBGrids, Borland.Vcl.IBCustomDataSet, Borland.Vcl.IBQuery,
  Borland.Vcl.ExtCtrls;

type
  TForm2 = class(TForm)
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    DataSource1: TDataSource;
    IBQuery1: TIBQuery;
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    Memo1: TMemo;
    select_: TButton;
    close_base_: TButton;
    update_data_: TButton;
    Panel2: TPanel;
    sql_edit_: TEdit;
    IBSQL1: TIBSQL;
    procedure FormCreate(Sender: TObject);
    procedure select_Click(Sender: TObject);
    procedure close_base_Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure update_data_Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation
  uses u_c_net_display, u_c_net_log;

{$R *.nfm}

    // const k_database_path= '..\_data\';
    //        k_database_name= 'Institut_Pascal_3.gdb';
    const k_table_name= 'formations_3';
          k_sql_update= 'UPDATE '+ k_table_name+ ' SET f_nom=''Interbase'' WHERE f_numero= 4';


    procedure TForm2.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
        sql_edit_.Text:= k_sql_update;
      end;

    procedure TForm2.select_Click(Sender: TObject);
      begin
        with IbQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('SELECT * FROM '+ k_table_name);
            display_strings(Sql);

            Try
              Open;
              display('  ok');
            except
              on e: Exception do
                display('  *** pb '+ e.Message);
            end;
          end; // with Sql
        end; // with IbQuery1
      end; // select_Click

    procedure TForm2.close_base_Click(Sender: TObject);
      begin
        IbQuery1.Close;
        IbDatabase1.Close;
      end; // close_base_Click

    procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
      begin
        close_base_Click(Nil);
      end; // FormClose

    procedure TForm2.update_data_Click(Sender: TObject);
      begin
        with IbSql1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add(sql_edit_.Text);
          end;

          display_strings(Sql);

          Try
            display('> ExecSql');
            ExecQuery;
            display('< ExecSql OK');
          except
            on e:exception do
              display('< *** pb_update '+ e.Message );
          end;
        end; // with IbQuery1
      end; // update_data_Click

end.
